
;;;; MOBILE_FORAGER
;;;; Grav-Basque
;;;; Version 0.5





;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 1. Variables and Agent-Types
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    ;;;;;;;;;;;;;;;;;;;;;;;
    ;; 1.1 Global Variables

    globals [
              ;;inno-counter

              day
              ;;total-days
              month
              year

              winter

              camp-sites
              pot-camp-sites

              camp-move-distance
              stage

              ;;death

               ]

    ;;;;;;;;;;;;;
    ;; 1.2 Agents' Variables

    turtles-own [ ]


       breed [humans human]
       humans-own [
                   energy_need
                   food-h
                   food-g

                   gender
                   age
                   partner
                   children
                   birthday



                   action
                   ;;target
                   last-return
                   last-distance

                   known-patches
                   well-known-patches

                   happiness
                   general-happiness
                   path
                   residential_change
                   fav-camp
                   fav-hab
                   fav-group
                   fav-log

                   camp
                   ]

       undirected-link-breed [knows know]
       links-own [level]

       patches-own [
                    class
                    habitat
                    access
                    raw
                    org-color
                    area


                    resource-g1
                    resource-g2
                    resource-h1
                    resource-h2
                    ]



;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 2. Setup
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


    ;;;;;;;;;;;;;;;;;;;;;;;
    ;; 2.1 Global Setup

    to setup

      clear-all
      set day 0

      import-pcolors "WP-Rivers-2.jpg"

       ask patches with [pcolor = 108.4] [set class 0 set access 0 set org-color 108.4]                           ;; Sea
       ask patches with [pcolor = 47.1] [set class 1 set access 1 set org-color 47.1]                        ;; Coast
       ask patches with [pcolor = 73.6] [set class 2 set access 1 set org-color 75]                        ;; Flatland
       ask patches with [pcolor = 105.7] [set class 3 set access 0.75 set org-color 74]                     ;; River
       ask patches with [pcolor = 44.4] [set class 4 set access 0.5 set org-color 77]                      ;; Hills low
       ask patches with [pcolor = 35.6] [set class 5 set access 0.3 set org-color 5 ]                      ;; Hills high
       ask patches with [pcolor = 43.1] [set class 6 set access 1 set org-color 56 ]                        ;; Plateau
       ask patches with [pcolor = 74.5] [set class 7 set access 0.75 set org-color 54 ]                          ;; Urbasa
       ask patches with [pcolor = 6.8] [set class 8 set access 0 set org-color 3 ]                          ;; Mountains


       set winter false

       patch-setup



      create-humans (PopSize / 2) [ set gender 0 human-setup ]
      create-humans (PopSize / 2) [ set gender 1 human-setup ]
      link-families
      setup-location
      set stage 1 if Scenario = "Special" [set stage 4]
      set camp-sites patches with [member? self [camp] of humans]

      set day 1
      ;;set total-days 1
      set month 7
      set year 1

      set camp-move-distance [0]

      reset-ticks

    end




    ;;;;;;;;;;;;;;;;;;;;;;;
    ;; 2.2 Human Setup

    to human-setup



      new-human

      set birthday (random 12 + 1)


        ;; set age

       ifelse gender = 0
      [let age-in-range random-float 1
      ifelse (age-in-range - 0.0278) < 0 [set age 0] [
        ifelse (age-in-range - 0.1153) < 0 [set age (random 4 + 1)] [
          ifelse (age-in-range - 0.2144) < 0 [set age (random 5 + 5)] [
            ifelse (age-in-range - 0.3094) < 0 [set age (random 5 + 10)] [
              ifelse (age-in-range - 0.4001) < 0 [set age (random 5 + 15)] [
                ifelse (age-in-range - 0.4856) < 0 [set age (random 5 + 20)] [
                  ifelse (age-in-range - 0.5654) < 0 [set age (random 5 + 25)] [
                    ifelse (age-in-range - 0.6391) < 0 [set age (random 5 + 30)] [
                      ifelse (age-in-range - 0.7065) < 0 [set age (random 5 + 35)] [
                        ifelse (age-in-range - 0.7679) < 0 [set age (random 5 + 40)] [
                          ifelse (age-in-range - 0.8231) < 0 [set age (random 5 + 45)] [
                            ifelse (age-in-range - 0.872) < 0 [set age (random 5 + 50)] [
                              ifelse (age-in-range - 0.9138) < 0 [set age (random 5 + 55)] [
                                ifelse (age-in-range - 0.9473) < 0 [set age (random 5 + 60)] [
                                  ifelse (age-in-range - 0.9719) < 0 [set age (random 5 + 65)] [
                                    ifelse (age-in-range - 0.9878) < 0 [set age (random 5 + 70)] [
                                      ifelse (age-in-range - 0.996) < 0 [set age (random 5 + 75)] [
                                        ifelse (age-in-range - 0.9991) < 0 [set age (random 5 + 80)] [
                                          ifelse (age-in-range - 0.9999) < 0 [set age (random 5 + 85)] [set age (random 5 + 90)]]]]]]]]]]]]]]]]]]]
        ]
        [let age-in-range random-float 1
      ifelse (age-in-range - 0.029) < 0 [set age 0] [
        ifelse (age-in-range - 0.1188) < 0 [set age (random 4 + 1)] [
          ifelse (age-in-range - 0.2208) < 0 [set age (random 5 + 5)] [
            ifelse (age-in-range - 0.3189) < 0 [set age (random 5 + 10)] [
              ifelse (age-in-range - 0.4132) < 0 [set age (random 5 + 15)] [
                ifelse (age-in-range - 0.5023) < 0 [set age (random 5 + 20)] [
                  ifelse (age-in-range - 0.5852) < 0 [set age (random 5 + 25)] [
                    ifelse (age-in-range - 0.6617) < 0 [set age (random 5 + 30)] [
                      ifelse (age-in-range - 0.7312) < 0 [set age (random 5 + 35)] [
                        ifelse (age-in-range - 0.7933) < 0 [set age (random 5 + 40)] [
                          ifelse (age-in-range - 0.8476) < 0 [set age (random 5 + 45)] [
                            ifelse (age-in-range - 0.8936) < 0 [set age (random 5 + 50)] [
                              ifelse (age-in-range - 0.931) < 0 [set age (random 5 + 55)] [
                                ifelse (age-in-range - 0.9597) < 0 [set age (random 5 + 60)] [
                                  ifelse (age-in-range - 0.9796) < 0 [set age (random 5 + 65)] [
                                    ifelse (age-in-range - 0.9917) < 0 [set age (random 5 + 70)] [
                                      ifelse (age-in-range - 0.9976) < 0 [set age (random 5 + 75)] [
                                        ifelse (age-in-range - 0.9995) < 0 [set age (random 5 + 80)] [
                            ifelse (age-in-range - 0.9999) < 0 [set age (random 5 + 85)] [set age (random 5 + 90)]]]]]]]]]]]]]]]]]]]
        ]

      set energy_need 0
      set food-g 500
      if age > 14 [set food-g random 4000]

      set action 0
      ;;set target nobody
      set camp nobody
      set residential_change false
      set happiness 0
      set general-happiness true
      set fav-camp 0
      set fav-hab 0
      set fav-group 0
      set fav-log 0

      if age > 14 [set size 1.2]





    end

      to new-human

        ifelse gender = 0 [set color blue] [set color red]
        set shape "circle"
        set size 1
        ;;set target nobody
        set last-return [2000]
        set last-distance [0]
      end

   to link-families

      ask humans [set partner nobody set children (turtle-set)]

         ;; random selection of spouses for the adult female foragers:

      ask humans with [gender = 0 and age >= 17]
      [
         let my-age age
         let potential-partners (turtle-set humans with [gender = 1 and partner = nobody and age <= (my-age + 10) and age > my-age])
         if (any? potential-partners)
            [let best-partner (one-of potential-partners)
             set partner best-partner
             ask best-partner [set partner myself]
              ]
        ]


       ;; random selection of mothers and identification of fathers and siblings - if possible

      ask humans
        [
          let my-age age
          let potential-mothers (turtle-set humans with
            [
              (gender = 0)
              and (age > (18 + my-age) and age < (49 + my-age))
              and (not any? children with [(age < (my-age + 2)) and (age > (my-age - 2))])
              ])


          ifelse (any? potential-mothers)
             [
               let mother nobody
               set potential-mothers (sort-on [age] potential-mothers)
               let nr-of-pm length potential-mothers
               let position-of-m-in-list round ((nr-of-pm - 1) * (random-float 1 * random-float 1))
               set mother (item position-of-m-in-list potential-mothers)
               let father [partner] of mother

               if (father != nobody) [ask father [set children (turtle-set children myself)]]     ;; creats directed link (called "child") to the partner of the selected mother who is seen here as the father

               ask mother [set children (turtle-set children myself)]
              ]

              [
                   let potential-fathers (turtle-set humans with [(gender = 1) and (age > (20 + my-age)) and (partner = nobody) and (not any? children with [(age < (my-age + 1)) and (age > (my-age - 1))])])
                   if (any? potential-fathers)
                       [
                         ask one-of potential-fathers [set children (turtle-set children myself)]
                        ]

               ]
        ]




   end

   to setup-location

      ask humans [set camp nobody]

      while [any? humans with [camp = nobody]]
          [
           ask one-of humans with [camp = nobody and age > 14]
                                    [
                                        let household (turtle-set self partner children with [age < 15])
                                        let setup-locations patches with [habitat = 2]
                                        if Scenario = "Special" [set setup-locations patches with [area > 11 and area < 20 and habitat = 2]]

                                        ifelse not any? setup-locations with [any? humans-here and count humans-here < GroupSize]
                                                                   [let my-camp one-of setup-locations with [not any? humans-here and not any? humans in-radius 6 ]
                                                                    ask household [set camp my-camp move-to camp]]
                                                                   [let my-camp one-of setup-locations with [any? humans-here and count humans-here < GroupSize]
                                                                    ask household [set camp my-camp move-to camp ] ]

                                     ]
          ]

        ask humans with [age > 14] [set known-patches patches with [(pxcor > [[pxcor] of patch-here - 4] of myself) and (pxcor < [[pxcor] of patch-here + 4] of myself) and (pycor > 15)]]
        ask humans with [age > 9] [set known-patches patches in-radius 6]

        set camp-sites patches with [member? self [camp] of humans]
        set pot-camp-sites (patch-set camp-sites [patches in-radius 3] of camp-sites patches with [habitat = 0])

        while [any? humans with [fav-camp = 0]]
                          [ask one-of humans with [fav-camp = 0]
                                [
                                ifelse Scenario = "Special" and fav-camp = 0
                                    [let wc ([area] of camp + 10)
                                     let lsc ([area] of camp + 30)
                                     let sc ([area] of camp)
                                     set fav-camp (list wc wc wc sc sc sc lsc lsc lsc wc wc wc)
                                     set fav-group (list 50 50 50 30 30 30 15 15 15 50 50 50)
                                     set fav-log (list 2 2 4 2 1 2 4 5 5 2 4 2)
                                     set fav-hab (list 3 3 3 2 2 2 4 4 4 3 3 3)
                                     ask humans-here [set fav-camp [fav-camp] of myself set fav-group [fav-group] of myself set fav-log [fav-log] of myself set fav-hab [fav-hab] of myself]]
                                    [set fav-camp [0 0 0 0 0 0 0 0 0 0 0 0]]
                                ]
                          ]
    end


    ;;;;;;;;;;;;;;;;;;;;;;;
    ;; 2.3 Resource Setup


    to patch-setup


       ask patches [set habitat 0]
       ask patches with [class = 1] [set habitat 1]
       ask patches with [class = 2] [set habitat 2]
       ask patches with [class = 3] [set habitat 3]
       ask patches with [class = 4] [set habitat 4]
       ask patches with [class = 5] [set habitat 5]
       ask patches with [class = 6 or class = 7] [set habitat 6]

       ask patches [set raw 0]
       ask (patch-set patch 8 32 patch 24 29 patch 47 28 patch 48 29 patch 51 28 patch 53 30 patch 54 30 patch 55 31 patch 56 31 patch 60 33 patch  65 33 patch 66 33) [set raw 1]
       ask (patch-set patch 13 18 patch 4 13 patch 6 12 patch 8 11 patch 12 6 patch 13 7 patch 14 8 patch 16 3 patch 29 6 patch 74 17 patch 75 17  patch 75 42 patch 76 41 patch 77 40 patch 79 32 patch 80 35 patch 82 34 patch 83 32 patch 85 34) [set raw 2]
       ask (patch-set patch 35 11 patch 36 11 patch 37 11 patch 38 11 patch 39 11) [set raw 3]
       ;; ask patches with [raw > 0] [set pcolor red]

      update-environment

      ask patches with [pxcor < 5 and pycor > 29] [set area 1 ]
      ask patches with [pxcor < 10 and pxcor > 4 and pycor > 29] [set area 2 ]
      ask patches with [pxcor < 15 and pxcor > 9 and pycor > 29] [set area 3 ]
      ask patches with [pxcor < 20 and pxcor > 14 and pycor > 29] [set area 4 ]
      ask patches with [pxcor < 25 and pxcor > 19 and pycor > 29] [set area 5 ]
      ask patches with [pxcor < 30 and pxcor > 24 and pycor > 29] [set area 6 ]
      ask patches with [pxcor < 35 and pxcor > 29 and pycor > 29] [set area 7 ]
      ask patches with [pxcor < 40 and pxcor > 34 and pycor > 29] [set area 8 ]
      ask patches with [pxcor < 45 and pxcor > 39 and pycor > 29] [set area 9 ]
      ask patches with [pxcor > 45 and pycor > 30] [set area 10 ]

      ask patches with [pxcor < 5 and pycor > 25 and pycor < 30 and pycor > 24] [set area 11]
      ask patches with [pxcor < 10 and pxcor > 4 and pycor < 30 and pycor > 24] [set area 12 ]
      ask patches with [pxcor < 15 and pxcor > 9 and pycor < 30 and pycor > 24] [set area 13 ]
      ask patches with [pxcor < 20 and pxcor > 14 and pycor < 30 and pycor > 24] [set area 14 ]
      ask patches with [pxcor < 25 and pxcor > 19 and pycor < 30 and pycor > 24] [set area 15 ]
      ask patches with [pxcor < 30 and pxcor > 24 and pycor < 30 and pycor > 24] [set area 16 ]
      ask patches with [pxcor < 35 and pxcor > 29 and pycor < 30 and pycor > 24] [set area 17 ]
      ask patches with [pxcor < 40 and pxcor > 34 and pycor < 30 and pycor > 24] [set area 18 ]
      ask patches with [pxcor < 45 and pxcor > 39 and pycor < 30 and pycor > 24] [set area 19 ]
      ask patches with [pxcor > 45 and pycor < 30 and pycor > 24] [set area 20 ]

      ask patches with [pxcor < 5 and pycor > 25 and pycor < 25 and pycor > 19] [set area 21]
      ask patches with [pxcor < 10 and pxcor > 4 and pycor < 25 and pycor > 19] [set area 22 ]
      ask patches with [pxcor < 15 and pxcor > 9 and pycor < 25 and pycor > 19] [set area 23 ]
      ask patches with [pxcor < 20 and pxcor > 14 and pycor < 25 and pycor > 19] [set area 24 ]
      ask patches with [pxcor < 25 and pxcor > 19 and pycor < 25 and pycor > 19] [set area 25 ]
      ask patches with [pxcor < 30 and pxcor > 24 and pycor < 25 and pycor > 19] [set area 26 ]
      ask patches with [pxcor < 35 and pxcor > 29 and pycor < 25 and pycor > 19] [set area 27 ]
      ask patches with [pxcor < 40 and pxcor > 34 and pycor < 25 and pycor > 19] [set area 28 ]
      ask patches with [pxcor < 45 and pxcor > 39 and pycor < 25 and pycor > 19] [set area 29 ]
      ask patches with [pxcor > 45 and pycor < 25 and pycor > 19] [set area 30 ]

      ask patches with [pxcor < 5 and pycor > 25 and pycor < 20 and pycor > 14] [set area 31]
      ask patches with [pxcor < 10 and pxcor > 4 and pycor < 20 and pycor > 14] [set area 32 ]
      ask patches with [pxcor < 15 and pxcor > 9 and pycor < 20 and pycor > 14] [set area 33 ]
      ask patches with [pxcor < 20 and pxcor > 14 and pycor < 20 and pycor > 14] [set area 34 ]
      ask patches with [pxcor < 25 and pxcor > 19 and pycor < 20 and pycor > 14] [set area 35 ]
      ask patches with [pxcor < 30 and pxcor > 24 and pycor < 20 and pycor > 14] [set area 36 ]
      ask patches with [pxcor < 35 and pxcor > 29 and pycor < 20 and pycor > 14] [set area 37 ]
      ask patches with [pxcor < 40 and pxcor > 34 and pycor < 20 and pycor > 14] [set area 38 ]
      ask patches with [pxcor < 45 and pxcor > 39 and pycor < 20 and pycor > 14] [set area 39 ]
      ask patches with [pxcor > 45 and pycor < 20 and pycor > 14] [set area 40 ]

      ask patches with [pxcor < 5 and pycor > 25 and pycor < 15 and pycor > 9] [set area 41]
      ask patches with [pxcor < 10 and pxcor > 4 and pycor < 15 and pycor > 9] [set area 42 ]
      ask patches with [pxcor < 15 and pxcor > 9 and pycor < 15 and pycor > 9] [set area 43 ]
      ask patches with [pxcor < 20 and pxcor > 14 and pycor < 15 and pycor > 9] [set area 44 ]
      ask patches with [pxcor < 25 and pxcor > 19 and pycor < 15 and pycor > 9] [set area 45 ]
      ask patches with [pxcor < 30 and pxcor > 24 and pycor < 15 and pycor > 9] [set area 46 ]
      ask patches with [pxcor < 35 and pxcor > 29 and pycor < 15 and pycor > 9] [set area 47 ]
      ask patches with [pxcor < 40 and pxcor > 34 and pycor < 15 and pycor > 9] [set area 48 ]
      ask patches with [pxcor < 45 and pxcor > 39 and pycor < 15 and pycor > 9] [set area 49 ]
      ask patches with [pxcor > 45 and pycor < 15 and pycor > 9] [set area 50 ]

      ask patches with [pxcor < 5 and pycor > 25 and pycor < 10 and pycor > 4] [set area 51]
      ask patches with [pxcor < 10 and pxcor > 4 and pycor < 10 and pycor > 4] [set area 52 ]
      ask patches with [pxcor < 15 and pxcor > 9 and pycor < 10 and pycor > 4] [set area 53 ]
      ask patches with [pxcor < 20 and pxcor > 14 and pycor < 10 and pycor > 4] [set area 54 ]
      ask patches with [pxcor < 25 and pxcor > 19 and pycor < 10 and pycor > 4] [set area 55 ]
      ask patches with [pxcor < 30 and pxcor > 24 and pycor < 10 and pycor > 4] [set area 56 ]
      ask patches with [pxcor < 35 and pxcor > 29 and pycor < 10 and pycor > 4] [set area 57 ]
      ask patches with [pxcor < 40 and pxcor > 34 and pycor < 10 and pycor > 4] [set area 58 ]
      ask patches with [pxcor < 45 and pxcor > 39 and pycor < 10 and pycor > 4] [set area 59 ]
      ask patches with [pxcor > 45 and pycor < 10 and pycor > 4] [set area 60 ]

      ask patches with [pxcor < 5 and pycor > 25 and pycor < 5 ] [set area 61]
      ask patches with [pxcor < 10 and pxcor > 4 and pycor < 5 ] [set area 62 ]
      ask patches with [pxcor < 15 and pxcor > 9 and pycor < 5 ] [set area 63 ]
      ask patches with [pxcor < 20 and pxcor > 14 and pycor < 5 ] [set area 64 ]
      ask patches with [pxcor < 25 and pxcor > 19 and pycor < 5 ] [set area 65 ]
      ask patches with [pxcor < 30 and pxcor > 24 and pycor < 5 ] [set area 66 ]
      ask patches with [pxcor < 35 and pxcor > 29 and pycor < 5 ] [set area 67 ]
      ask patches with [pxcor < 40 and pxcor > 34 and pycor < 5 ] [set area 68 ]
      ask patches with [pxcor < 45 and pxcor > 39 and pycor < 5 ] [set area 69 ]
      ask patches with [pxcor > 45 and pycor < 5 and pycor > 9] [set area 70 ]
    end






;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 3. Simulation-Run Procedures
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;  3.1 General Procedure per Simulation-Turn

    to go

       update-time
       if day = 1 [if month = 3 [set winter false ]
                   if month = 10 [set winter true]
                   update-environment]

       if day = 15 [ask humans with [birthday = month] [demo-procedures]
                    ;;innovation-check
                    ]

        if (day = 10 or day = 25) [
                                   ask camp-sites with [any? humans-here][ask one-of humans-here with-max [age] [if length last-return > 3 and all? (humans with [camp = [camp] of myself]) [patch-here = camp] [check-moving-for]]]]


       ask humans with [age > 14] [check-action]

       if Sharing = true [ask humans with [age > 14 and food-h > 0] [meat-sharing] ]
       ask humans with [age > 14 and any? ((turtle-set children with [age < 15] partner) with [food-g < 2000])] [hh-sharing]
       ask humans with [energy_need > 5000 and (food-g + food-h) < 5000][share-on-demand]
       ask humans [ifelse age < 15 [set energy_need (energy_need + (age * 130))][set energy_need (energy_need + 2000)]
                   eat
                   ifelse energy_need > 0 [if happiness > -20 [set happiness (happiness - 1)]][if happiness < 20 [set happiness (happiness + 1)]]
                   if gender = 0 and happiness < 0  and general-happiness = true [set general-happiness false]
                   if energy_need > 4000 or happiness < -1 [set residential_change true]]

       ask humans with [energy_need > (60000)] [check-consequences die] ;; show age show gender
       if not any? (turtle-set humans) [ stop ]



       if member? day [5 10 20 25] [set camp-sites patches with [member? self [camp] of humans]
                                    set pot-camp-sites (patch-set camp-sites [patches in-radius 6] of camp-sites patches with [habitat = 0])]

       if MapType = "ResourcesG" or MapType = "ResourcesH" [update-map]
       if count humans < PopSize * 0.7 [set Scenario "Flexible" set stage 1]

       ;;if (ticks = 720000) [stop]
       if (ticks = 360000) [stop]


    tick


    end


    to update-time

       set day (day + 1)
       ;;set total-days (total-days + 1)
       if day = 31 [set day 1 set month (month + 1) ]
       if month = 13 [set month 1 set year (year + 1) ]
    end



    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; 3.2.1 Forager Decision-Making Procedures

   to check-action

      if action = 0 [select-action]
      if action = 1 []
      if action = 2 [
                     ;;go-to-target
                     ]
      if action = 3 []
      if action = 4 [log-forage]
      if action = 5 and age > 14 [move-camp]


   end

   to select-action


      if (day = 5 or day = 20) [if (happiness > 10 or (happiness < -1 or energy_need > 6000)) and (partner = nobody or [patch-here] of partner = patch-here) [check-moving-soc]]


      if action = 0
            [


              ifelse age < 15
                     [if (energy_need + (age * 130)) > food-g [day-forage-g]]
                     [
                      ifelse gender = 0  [if food-g < (energy_need + 2000 + sum [energy_need + (age * 130) - food-g] of children with [age < 15 and food-g < (energy_need + (age * 130))]) [day-forage-g]]
                                         [ let adults humans-here with [age > 14]
                                           if (sum [food-g] of adults < sum [energy_need + 2000] of adults) [ifelse (count humans-here with [age > 15]) > 10 and stage > 1 [check-log-forage][day-forage-h]]]
                     ]
            ]

   end

   to day-forage-g


         let potential-patches patches with [distance myself < 6]

         let forage-patch nobody



         let return 0

                          set forage-patch one-of potential-patches with-max [(resource-g1 * 0.05 * (1 - (0.0416 *  (2 * distance myself)))) - (distance myself * 220)]
                          ifelse age > 14 [set return floor [resource-g1 * 0.05 * (1 - (0.0416 * (2 * distance myself)))] of forage-patch]
                                          [set return floor [resource-g1 * 0.02  * (1 - (0.0416 * (2 * distance myself)))] of forage-patch]
                          ifelse return > (distance forage-patch * 220) [set energy_need (energy_need + (distance forage-patch * 220))
                                                                         set last-distance (fput distance forage-patch last-distance) if length last-distance > 4 [set last-distance (but-last last-distance)]] [set return 0]







                        let extra 0 set food-g (food-g + return )
                        ask forage-patch [
                                        set resource-g1 (resource-g1 - return) if resource-g1 < 0 [set resource-g1 0]
                                        ]
         let costs (distance forage-patch * 220)
         set last-return fput floor (return - costs)  last-return
         if length last-return > 4 [set last-return but-last last-return]
    end

    to day-forage-h

        let potential-patches patches with [distance myself < 12 and resource-h1 > 20000]

         let forage-patch nobody



         let return 0

         ifelse any? potential-patches
                         [set forage-patch one-of potential-patches with-max [(((30000) * 0.5 * (1 - (0.0416 *  (2 * distance myself)))) - (distance myself * 220)) ]
                          set return [((30000) * 0.5 * (1 - (0.0416 *  (2 * distance myself)))) - (distance myself * 220)] of forage-patch
                          ifelse return > (distance forage-patch * 220)
                             [ifelse random 100 < (50 * (1 - (0.0416 *  (2 * distance forage-patch))) )
                                 [set return floor (20000 + (random 40000)) if [resource-h1] of forage-patch < return [set return [resource-h1] of forage-patch]]
                                 [set return 0]
                               set energy_need (energy_need + (distance forage-patch * 220))
                               set last-distance (fput distance forage-patch last-distance) if length last-distance > 4 [set last-distance (but-last last-distance)]]
                             [set return 0]
                             if  return > 0
                                           [

                                            set food-h (food-h + return)
                                            ask forage-patch [ set resource-h1 (resource-h1 - return)
                                                               if  1 < count neighbors with [habitat != 0 and not member? self camp-sites] [let fleeing floor (0.5 * resource-h1) set resource-h1 fleeing ask n-of 2 neighbors with [habitat != 0 and not member? self camp-sites] [set resource-h1 (resource-h1 + (fleeing * 0.5))]]


                                                             ]


                                             ]
                             let costs 0
                             if forage-patch != nobody  [set costs (distance forage-patch * 220)]
                             set last-return fput floor (return - costs)  last-return
                             if length last-return > 4 [set last-return but-last last-return]
                          ]
                         [day-forage-g]



    end

    to check-moving-for


           let new-camp nobody
           let new-camp-rr 0

           let travel-group humans with [camp = [camp] of myself]

           let camp-distance-max 15
           let camp-distance-min 6
           if any? humans-here with [gender = 0 and age > 15 and not empty? last-distance] [set camp-distance-min (mean [first last-distance] of humans-here with [gender = 0 and age > 15 and not empty? last-distance] )]
           let potential-camps patches with [member? self [known-patches] of myself and distance myself > (camp-distance-min * 1.5) and distance myself < camp-distance-max and not member? self pot-camp-sites]

         if stage = 1 [
                        let moving-target one-of (potential-camps with-max [sum [resource-h1] of neighbors])
                        set potential-camps potential-camps with [(distance myself + distance moving-target) < (1.5 * [distance moving-target] of myself)]
                        set new-camp one-of potential-camps with-max [mean [resource-g1 * 0.05] of neighbors - (distance myself * 120)]

                        ]
          if stage = 2 [
                        let target-habitat item (month - 1) fav-camp
                        ifelse any? potential-camps with [habitat = target-habitat] [set potential-camps potential-camps with [habitat = target-habitat]]
                                                         [set potential-camps potential-camps with [(distance myself + distance one-of (patches with [habitat = target-habitat]) with-min [distance myself]) < (1.5 * distance one-of (patches with [habitat = target-habitat]) with-min [distance myself])]]
                           set new-camp one-of potential-camps with-max [mean [resource-g1 * 0.05] of neighbors - (distance myself * 120)]

                          ]

          if stage > 2 and [area] of camp != item (month - 1) fav-camp
                          [

                               let target-area item (month - 1) fav-camp
                               ifelse any? patches with [distance myself < 15 and area = target-area]
                                      [ifelse any? patches with [area = target-area and member? self camp-sites]
                                          [set new-camp one-of patches with [area = target-area and member? self camp-sites]]
                                          [set new-camp one-of (patches with [area = target-area]) with-max [sum [resource-g1] of patches in-radius 3]]
                                        ]
                                      [
                                        let target-patch one-of patches with [area = target-area]
                                        set potential-camps potential-camps with [(distance myself + distance target-patch ) < (1.5 * (distance myself + distance target-patch))]
                                        set new-camp one-of potential-camps with-max [mean [resource-g1 * 0.05] of neighbors - (distance myself * 120)]
                                        ]
                          ]

         if new-camp != nobody [set new-camp-rr ((mean [resource-g1 * 0.05] of [neighbors] of new-camp * 0.66) - (distance myself * 120))]

          if new-camp != nobody [
                                 let current-rr mean last-return
                                  ifelse any? travel-group with [age > 14 and gender = 0 and not empty? last-return] [set current-rr ( mean [mean last-return] of travel-group with [age > 14 and gender = 0 and not empty? last-return] )]
                                           [set new-camp-rr ((15000 * 0.125 * [count neighbors with [resource-h1 > 20000]] of new-camp) * 0.66) - (distance myself * 120)]

             ifelse new-camp-rr > current-rr
                               [ask travel-group [set action 5 set camp new-camp
                                   set camp-move-distance (fput distance camp camp-move-distance) if length camp-move-distance > 5 [set camp-move-distance but-last camp-move-distance]
                                   ;;set residential_change false
                                   ]

                               set pot-camp-sites (patch-set pot-camp-sites [patches in-radius 3] of camp) set camp-sites (patch-set camp-sites camp)
                               ]
                               [
                                if mean [happiness] of travel-group > 15 and stage < 3
                                    [
                                      let other-camps patches with [member? self [known-patches] of myself and any? humans-here and member? self camp-sites and self != [camp] of myself and mean [happiness] of humans-here > 15]
                                      if any? other-camps [set new-camp one-of other-camps with-min [distance myself]
                                                           ask travel-group [set action 5 set camp new-camp
                                                             ;;set residential_change false
                                                             ]
                                                           set pot-camp-sites (patch-set pot-camp-sites [patches in-radius 6] of camp) set camp-sites (patch-set camp-sites camp)
                                                           ]

                                      ]

                                ]
                                     ]



    end

  to check-moving-soc


           let new-camp nobody

           let travel-group (turtle-set self partner children with [patch-here = [patch-here] of myself and partner = nobody])

           if happiness >= 10
             [
              let other-camps camp-sites with [distance myself < 8 and any? humans-here and self != [camp] of myself and mean [happiness] of humans-here > 10]
              if any? other-camps [set new-camp one-of other-camps with-min [distance myself]]
              ]
           if happiness < -1
              [
               ;;let camp-distance-max [first last-distance] of one-of travel-group with-max [first last-distance]
               ;;let camp-distance-min 3
               ;;if any? travel-group with [gender = 0 and age > 14 and not empty? last-distance] [set camp-distance-min (mean [first last-distance] of travel-group with [gender = 0 and age > 14 and not empty? last-distance])]
               ;;let potential-camps patches with [distance myself > (camp-distance-min * 2) and distance myself < (camp-distance-max * 2) and not member? self pot-camp-sites and habitat != 0]


               ifelse stage < 3
                    [ifelse any? camp-sites with [distance myself < 10 and any? humans-here and mean [happiness] of humans-here > 10]
                               [ set new-camp one-of (camp-sites with [any? humans-here and mean [happiness] of humans-here > 10]) with-min [distance myself]]
                               [let potential-camps patches with [distance myself > 6 and distance myself < 12 and not member? self pot-camp-sites]
                                if any? potential-camps [set new-camp one-of potential-camps with-max [sum [resource-g1] of patches in-radius 3]]]
                     ]

                    [if [area] of camp != item (month - 1) fav-camp
                             [
                               let target-area item (month - 1) fav-camp
                               ifelse any? patches with [area = target-area and member? self camp-sites]
                                          [set new-camp one-of patches with [area = target-area and member? self camp-sites]]
                                          [set new-camp one-of (patches with [area = target-area]) with-max [sum [resource-g1] of patches in-radius 3]]

                             ]
                      ]
              ]

          ifelse new-camp != nobody [ask travel-group [set action 5 set camp new-camp
                                                       set camp-move-distance (fput distance camp camp-move-distance) if length camp-move-distance > 5 [set camp-move-distance but-last camp-move-distance]
                                                       ]
                                     set camp-sites (patch-set camp-sites camp)
                                     set pot-camp-sites (patch-set pot-camp-sites [patches in-radius 6] of camp)
                                     move-camp] [set action 0]



    end





    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;; 3.2.2 Forager Action Procedures




 ;;   to go-to-target

 ;;     ifelse member? target patches in-radius 6 [ifelse target = camp [set energy_need (energy_need + (distance target * 360)) set action 0]
 ;;                                                                     [set energy_need (energy_need + (distance target * 300))]
 ;;                                                move-to target ]
 ;;                                               [face target fd 6 ifelse target = camp [set energy_need (energy_need + 2160)] [set energy_need (energy_need + 1800)]]

 ;;   end



    to eat

      ifelse (((food-g + food-h) - energy_need) < 0)
          [ set energy_need (energy_need - (food-g + food-h)) set food-g 0 set food-h 0]
          [ let food-x (food-g + food-h)
            set food-h 0
            set food-g (food-x - energy_need)
            set energy_need 0]

    end

    to log-forage

      let taskforce humans-here
      ifelse ((sum [(food-g + food-h) - energy_need] of taskforce) / count taskforce) > 10000 or (partner != nobody and [happiness] of partner < 0)
            [move-camp ]
            [

             let potential-patches patches with [distance myself < 12]
             set potential-patches potential-patches with [resource-h1 > 20000]
             let forage-patch one-of potential-patches with-max [(((30000) * 0.5 * (1 - (0.0416 *  (2 * distance myself)))) - (distance myself * 220)) ]
             ifelse forage-patch = nobody [move-camp]
                [
                 let return [((30000) * 0.5 * (1 - (0.0416 *  (2 * distance myself)))) - (distance myself * 220)] of forage-patch
                 ifelse return > (distance forage-patch * 220)
                             [ifelse random 100 < (50 * (1 - (0.0416 *  (2 * distance forage-patch))) )
                                 [set return floor (20000 + (random 40000)) if [resource-h1] of forage-patch < return [set return [resource-h1] of forage-patch]]
                                 [set return 0]
                               set energy_need (energy_need + (distance forage-patch * 220))
                               set last-distance (fput distance forage-patch last-distance) if length last-distance > 4 [set last-distance (but-last last-distance)]]
                             [set return 0]
                 if  return > 0
                       [

                        set food-h (food-h + return)
                        ask forage-patch [
                                          set resource-h1 (resource-h1 - return)
                                          if  1 < count neighbors with [habitat != 0 and not member? self camp-sites] [let fleeing floor (0.5 * resource-h1) set resource-h1 fleeing ask n-of 2 neighbors with [habitat != 0 and not member? self camp-sites] [set resource-h1 (resource-h1 + (fleeing * 0.5))]]
                                           ]


                        ]
                 let costs 0
                 if forage-patch != nobody  [set costs (distance forage-patch * 220)]
                 set last-return fput floor (return - costs)  last-return
                 if length last-return > 4 [set last-return but-last last-return]
                ]
            ]




    end


    to check-log-forage

      let foraging false

      if ((count humans-here with [gender = 1 and age > 19 and action = 0] > 2) and (partner = nobody or [happiness] of partner > 0 ))
        [set foraging true]

      if foraging = true [let taskforce nobody
                          let temp-camp nobody
                          let pot-task humans-here with [gender = 1 and age > 19 and action = 0]
                          ifelse count pot-task < 6 [set taskforce (turtle-set self n-of (count pot-task - 1) pot-task)][set taskforce (turtle-set self n-of 5 pot-task)]
                          let target-habitat item (month - 1) fav-log

                          let potential-temp-camp patches with [distance myself > 6 and distance myself < 15 and habitat = target-habitat and not any? humans in-radius 5]
                          if any? potential-temp-camp with [habitat = target-habitat][set potential-temp-camp potential-temp-camp with [habitat = target-habitat]]
                          set temp-camp one-of potential-temp-camp with-max [(((30000) * 0.5 * (1 - (0.0416 *  (2 * distance myself)))) - (distance myself * 220)) ]

                          ifelse temp-camp != nobody [ask taskforce [set action 4 move-to temp-camp set shape "triangle"]]
                                                     [set foraging false ]
                          ]


      if foraging = false [day-forage-h]

    end

    to move-camp



      if Draw = true [pen-down]
      ifelse distance camp < 24 [set energy_need (energy_need + (360 * distance camp)) move-to camp if action = 5 [set happiness 0 set known-patches (patch-set known-patches patches in-radius 6) set last-return [0] set last-distance [0] set residential_change  false ] set action 0 set shape "circle"]
                                              [face camp let temp-camp patch-ahead 6 set shape "triangle 2"
                                               ifelse [habitat] of temp-camp = 0 or [class] of temp-camp = 8 [set temp-camp one-of (patches with [distance myself > 5.5 and distance myself < 6.5 and habitat != 0 and class != 8]) with-min [distance [camp] of myself] face temp-camp fd 6][fd 6]
                                               set energy_need (energy_need + 2160) set known-patches (patch-set known-patches patches in-radius 6) set shape "triangle"]
      if any? children with [age < 15 and patch-here != [patch-here] of myself] [ask children with [age < 15] [move-to myself set action 0] ask children with [age > 10] [set known-patches (patch-set known-patches patches in-radius 6)]]
      pen-up


    end


    to meat-sharing               ;; SubFor: ShareComp

      if food-h > 0 [let share floor (food-h / (count humans-here with [age > 9]))
                     set food-h 0
                     ask humans-here with [age > 9][set food-h (food-h + share)]]
    end

    to share-on-demand

      let donor one-of humans-here with-max [food-g]
      if [food-g - 2000 - energy_need] of donor > 100 [
                                                        let share floor ([food-g - 2000 - energy_need] of donor * 0.5)
                                                        ask donor [set food-g (food-g - share)]
                                                        set food-g (food-g + share)
                                                        ]

    end

    to hh-sharing

      set food-g (food-g + food-h)
      if food-g > 2000 and any? children with [age < 15 and (food-g + food-h) < ((130 * age) + energy_need) and patch-here = [patch-here] of myself]
            [
              let hungry-children children with [age < 15 and (food-g + food-h) < ((130 * age) + energy_need) and patch-here = [patch-here] of myself]
              ifelse sum [ (energy_need + (age * 130)) - (food-g + food-h)] of hungry-children < (food-g - 2000 - energy_need)
                  [set food-g floor (food-g - sum [ (energy_need + (age * 130)) - (food-g + food-h)] of hungry-children)
                    ask hungry-children [set food-g ceiling (energy_need + (age * 130)) set food-h 0] ]
                  [let share floor (food-g - 1000 - energy_need)
                   if share >  0[set food-g (food-g - share)
                                 set share floor (share / sum [age] of hungry-children)
                                 ask hungry-children [set food-g (food-g + share * age)]]]
            ]
      if partner != nobody and food-g > 2000 [if [food-g + food-h] of partner < (food-g + food-h) and patch-here = [patch-here] of partner
                                                 [let share floor ((food-g + food-h + [food-g + food-h] of partner) * 0.5) set food-g share set food-h 0 ask partner [set food-g share set food-h 0]]]

    end






    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;  3.3 Resource Procedures


    to update-environment


      let glacial true
      let h1-g1 0 let h2-g1 0 let h3-g1 0 let h4-g1 0 let h5-g1 0 let h6-g1 0
      let h1-g2 0 let h2-g2 0 let h3-g2 0 let h4-g2 0 let h5-g2 0 let h6-g2 0
      let h1-h1 0 let h2-h1 0 let h3-h1 0 let h4-h1 0 let h5-h1 0 let h6-h1 0
      let h1-h2 0 let h2-h2 0 let h3-h2 0 let h4-h2 0 let h5-h2 0 let h6-h2 0

      if EnvironScen = 2 [ if (year > 100 and year < 200) or (year > 800 and year < 1000) or EnvironScen = 3 [set glacial false] ]

      ifelse (glacial = true)
         [

           ifelse winter = true
                [
                 set h1-g1 (100000 * 0.01 * EnvironQuality) set h2-g1 (100000 * 0.01 * EnvironQuality) set h3-g1 (200000 * 0.01 * EnvironQuality) set h4-g1 (200000 * 0.01 * EnvironQuality) set h5-g1 (10000 * 0.01 * EnvironQuality) set h6-g1 (10000 * 0.01 * EnvironQuality)
                 ;;set h1-g2 (16000 * 0.01 * EnvironQuality) set h2-g2 (16000 * 0.01 * EnvironQuality) set h3-g2 (16000 * 0.01 * EnvironQuality) set h4-g2 0
                 set h1-h1 (10000 * 0.01 * EnvironQuality) set h2-h1 (50000 * 0.01 * EnvironQuality) set h3-h1 (100000 * 0.01 * EnvironQuality) set h4-h1 (100000 * 0.01 * EnvironQuality) set h5-h1 (10000 * 0.01 * EnvironQuality) set h6-h1 (10000 * 0.01 * EnvironQuality)
                 ;;set h1-h2 (100000 * 0.01 * EnvironQuality) set h2-h2 (50000 * 0.01 * EnvironQuality) set h3-h2 (250000 * 0.01 * EnvironQuality) set h4-h2 (250000 * 0.01 * EnvironQuality)
                ]
                [
                 set h1-g1 (200000 * 0.01 * EnvironQuality) set h2-g1 (100000 * 0.01 * EnvironQuality) set h3-g1 (200000 * 0.01 * EnvironQuality) set h4-g1 (100000 * 0.01 * EnvironQuality) set h5-g1 (10000 * 0.01 * EnvironQuality) set h6-g1 (100000 * 0.01 * EnvironQuality)
                 ;;set h1-g2 (800000 * 0.01 * EnvironQuality) set h2-g2 (1600000 * 0.01 * EnvironQuality) set h3-g2 (1600000 * 0.01 * EnvironQuality) set h4-g2 (200000 * 0.01 * EnvironQuality)
                 set h1-h1 (100000 * 0.01 * EnvironQuality) set h2-h1 (160000 * 0.01 * EnvironQuality) set h3-h1 (100000 * 0.01 * EnvironQuality) set h4-h1 (50000 * 0.01 * EnvironQuality) set h5-h1 (200000 * 0.01 * EnvironQuality) set h6-h1 (100000 * 0.01 * EnvironQuality)
                 ;;set h1-h2 (1000000 * 0.01 * EnvironQuality) set h2-h2 (500000 * 0.01 * EnvironQuality) set h3-h2 (500000 * 0.01 * EnvironQuality) set h4-h2 (1000000 * 0.01 * EnvironQuality)
                ]
          ]
          [

           ifelse winter = true
                [
                 set h1-g1 (200000 * 0.01 * EnvironQuality) set h2-g1 (300000 * 0.01 * EnvironQuality) set h3-g1 (400000 * 0.01 * EnvironQuality) set h4-g1 (300000 * 0.01 * EnvironQuality)
                 ;;set h1-g2 (120000 * 0.01 * EnvironQuality) set h2-g2 (120000 * 0.01 * EnvironQuality) set h3-g2 (120000 * 0.01 * EnvironQuality) set h4-g2 (80000 * 0.01 * EnvironQuality)
                 set h1-h1 (10000 * 0.01 * EnvironQuality) set h2-h1 (50000 * 0.01 * EnvironQuality) set h3-h1 (100000 * 0.01 * EnvironQuality) set h4-h1 (100000 * 0.01 * EnvironQuality)
                 ;;set h1-h2 (250000 * 0.01 * EnvironQuality) set h2-h2 (500000 * 0.01 * EnvironQuality) set h3-h2 (500000 * 0.01 * EnvironQuality) set h4-h2 (50000 * 0.01 * EnvironQuality)
                ]
                [
                 set h1-g1 (200000 * 0.01 * EnvironQuality) set h2-g1 (800000 * 0.01 * EnvironQuality) set h3-g1 (3200000 * 0.01 * EnvironQuality) set h4-g1 (800000 * 0.01 * EnvironQuality)
                 ;;set h1-g2 (800000 * 0.01 * EnvironQuality) set h2-g2 (1600000 * 0.01 * EnvironQuality) set h3-g2 (1600000 * 0.01 * EnvironQuality) set h4-g2 (400000 * 0.01 * EnvironQuality)
                 set h1-h1 (60000 * 0.01 * EnvironQuality) set h2-h1 (60000 * 0.01 * EnvironQuality) set h3-h1 (100000 * 0.01 * EnvironQuality) set h4-h1 (100000 * 0.01 * EnvironQuality)
                 ;;set h1-h2 (1000000 * 0.01 * EnvironQuality) set h2-h2 (250000 * 0.01 * EnvironQuality) set h3-h2 (250000 * 0.01 * EnvironQuality) set h4-h2 (100000 * 0.01 * EnvironQuality)
                ]
          ]



         if (day = 0 or month = 4)
                     [
                       ask patches with [habitat = 1] [set resource-g1 h1-g1 set resource-h1 h1-h1
                                                       set resource-g2 h1-g2 set resource-h2 h1-h2]
                       ask patches with [habitat = 2] [set resource-g1 h2-g1 set resource-h1 h2-h1
                                                       set resource-g2 h2-g2 set resource-h2 h2-h2]
                       ask patches with [habitat = 3] [set resource-g1 h3-g1 set resource-h1 h3-h1
                                                       set resource-g2 h3-g2 set resource-h2 h3-h2]
                       ask patches with [habitat = 4] [set resource-g1 h4-g1 set resource-h1 h4-h1
                                                       set resource-g2 h4-g2 set resource-h2 h4-h2]


                     ]

        ;;             [
                       ask patches with [habitat = 1 and (resource-g1 < h1-g1 or resource-h1 < h1-h1 or resource-g2 < h1-g2 or resource-h2 < h1-h2) and not any? humans in-radius 3]
                               [if resource-g1 < h1-g1 [set resource-g1 (resource-g1 + (resource-g1 * 0.2)) if resource-g1 > h1-g1 [set resource-g1 h1-g1]]
                                if resource-g2 < h1-g2 [set resource-g2 (resource-g2 + (resource-g2 * 0.2)) if resource-g2 > h1-g2 [set resource-g2 h1-g2]]
                                if resource-h1 < h1-h1 [set resource-h1 (resource-h1 + (resource-h1 * 0.3)) if resource-h1 > h1-h1 [set resource-h1 h1-h1]]
                                if resource-h2 < h1-h2 [set resource-h2 (resource-h2 + (resource-h2 * 0.3)) if resource-h2 > h1-h2 [set resource-h2 h1-h2]]]
                       ask patches with [habitat = 2 and (resource-g1 < h2-g1 or resource-h1 < h2-h1 or resource-g2 < h2-g2 or resource-h2 < h2-h2) and not any? humans in-radius 3]
                               [if resource-g1 < h2-g1 [set resource-g1 (resource-g1 + (resource-g1 * 0.2)) if resource-g1 > h2-g1 [set resource-g1 h2-g1]]
                                if resource-g2 < h2-g2 [set resource-g2 (resource-g2 + (resource-g2 * 0.2)) if resource-g2 > h2-g2 [set resource-g2 h2-g2]]
                                if resource-h1 < h2-h1 [set resource-h1 (resource-h1 + (resource-h1 * 0.3)) if resource-h1 > h2-h1 [set resource-h1 h2-h1]]
                                if resource-h2 < h2-h2 [set resource-h2 (resource-h2 + (resource-h2 * 0.3)) if resource-h2 > h2-h2 [set resource-h2 h2-h2]]]
                       ask patches with [habitat = 3 and (resource-g1 < h3-g1 or resource-h1 < h3-h1 or resource-g2 < h3-g2 or resource-h2 < h3-h2) and not any? humans in-radius 3]
                               [if resource-g1 < h3-g1 [set resource-g1 (resource-g1 + (resource-g1 * 0.2)) if resource-g1 > h3-g1 [set resource-g1 h3-g1]]
                                if resource-g2 < h3-g2 [set resource-g2 (resource-g2 + (resource-g2 * 0.2)) if resource-g2 > h3-g2 [set resource-g2 h3-g2]]
                                if resource-h1 < h3-h1 [set resource-h1 (resource-h1 + (resource-h1 * 0.3)) if resource-h1 > h3-h1 [set resource-h1 h3-h1]]
                                if resource-h2 < h3-h2 [set resource-h2 (resource-h2 + (resource-h2 * 0.3)) if resource-h2 > h3-h2 [set resource-h2 h3-h2]]]
                       ask patches with [habitat = 4 and (resource-g1 < h4-g1 or resource-h1 < h4-h1 or resource-g2 < h4-g2 or resource-h2 < h4-h2) and not any? humans in-radius 3]
                               [if resource-g1 < h4-g1 [set resource-g1 (resource-g1 + (resource-g1 * 0.2)) if resource-g1 > h4-g1 [set resource-g1 h4-g1]]
                                if resource-g2 < h4-g2 [set resource-g2 (resource-g2 + (resource-g2 * 0.2)) if resource-g2 > h4-g2 [set resource-g2 h4-g2]]
                                if resource-h1 < h4-h1 [set resource-h1 (resource-h1 + (resource-h1 * 0.3)) if resource-h1 > h4-h1 [set resource-h1 h4-h1]]
                                if resource-h2 < h4-h2 [set resource-h2 (resource-h2 + (resource-h2 * 0.3)) if resource-h2 > h4-h2 [set resource-h2 h4-h2]]]
                       ask patches with [habitat = 5 and (resource-g1 < h5-g1 or resource-h1 < h5-h1 or resource-g2 < h5-g2 or resource-h2 < h5-h2) and not any? humans in-radius 3]
                               [if resource-g1 < h5-g1 [set resource-g1 (resource-g1 + (resource-g1 * 0.2)) if resource-g1 > h5-g1 [set resource-g1 h5-g1]]
                                if resource-g2 < h5-g2 [set resource-g2 (resource-g2 + (resource-g2 * 0.2)) if resource-g2 > h5-g2 [set resource-g2 h5-g2]]
                                if resource-h1 < h5-h1 [set resource-h1 (resource-h1 + (resource-h1 * 0.3)) if resource-h1 > h5-h1 [set resource-h1 h5-h1]]
                                if resource-h2 < h5-h2 [set resource-h2 (resource-h2 + (resource-h2 * 0.3)) if resource-h2 > h5-h2 [set resource-h2 h5-h2]]]
                       ask patches with [habitat = 6 and (resource-g1 < h4-g1 or resource-h1 < h4-h1 or resource-g2 < h4-g2 or resource-h2 < h4-h2) and not any? humans in-radius 3]
                               [if resource-g1 < h6-g1 [set resource-g1 (resource-g1 + (resource-g1 * 0.2)) if resource-g1 > h6-g1 [set resource-g1 h6-g1]]
                                if resource-g2 < h6-g2 [set resource-g2 (resource-g2 + (resource-g2 * 0.2)) if resource-g2 > h6-g2 [set resource-g2 h6-g2]]
                                if resource-h1 < h6-h1 [set resource-h1 (resource-h1 + (resource-h1 * 0.3)) if resource-h1 > h6-h1 [set resource-h1 h6-h1]]
                                if resource-h2 < h6-h2 [set resource-h2 (resource-h2 + (resource-h2 * 0.3)) if resource-h2 > h6-h2 [set resource-h2 h6-h2]]]

                       ask patches with [habitat = 1 and (resource-g1 > h1-g1 or resource-h1 > h1-h1 or resource-g2 > h1-g2 or resource-h2 > h1-h2) ]
                               [if resource-g1 > h1-g1 [set resource-g1 (resource-g1 - (resource-g1 * 0.2)) ]
                                if resource-g2 > h1-g2 [set resource-g2 (resource-g2 - (resource-g2 * 0.2)) ]
                                if resource-h1 > h1-h1 [set resource-h1 (resource-h1 - (resource-h1 * 0.2)) ]
                                if resource-h2 > h1-h2 [set resource-h2 (resource-h2 - (resource-h2 * 0.2)) ]]
                       ask patches with [habitat = 2 and (resource-g1 > h2-g1 or resource-h1 > h2-h1 or resource-g2 > h2-g2 or resource-h2 > h2-h2) ]
                               [if resource-g1 > h2-g1 [set resource-g1 (resource-g1 - (resource-g1 * 0.2)) ]
                                if resource-g2 > h2-g2 [set resource-g2 (resource-g2 - (resource-g2 * 0.2)) ]
                                if resource-h1 > h2-h1 [set resource-h1 (resource-h1 - (resource-h1 * 0.2)) ]
                                if resource-h2 > h2-h2 [set resource-h2 (resource-h2 - (resource-h2 * 0.2)) ]]
                       ask patches with [habitat = 3 and (resource-g1 > h3-g1 or resource-h1 > h3-h1 or resource-g2 > h3-g2 or resource-h2 > h3-h2) ]
                               [if resource-g1 > h3-g1 [set resource-g1 (resource-g1 - (resource-g1 * 0.2)) ]
                                if resource-g2 > h3-g2 [set resource-g2 (resource-g2 - (resource-g2 * 0.2))]
                                if resource-h1 > h3-h1 [set resource-h1 (resource-h1 - (resource-h1 * 0.2)) ]
                                if resource-h2 > h3-h2 [set resource-h2 (resource-h2 - (resource-h2 * 0.2)) ]]
                       ask patches with [habitat = 4 and (resource-g1 > h4-g1 or resource-h1 > h4-h1 or resource-g2 > h4-g2 or resource-h2 > h4-h2) ]
                               [if resource-g1 > h4-g1 [set resource-g1 (resource-g1 - (resource-g1 * 0.2)) ]
                                if resource-g2 > h4-g2 [set resource-g2 (resource-g2 - (resource-g2 * 0.2)) ]
                                if resource-h1 > h4-h1 [set resource-h1 (resource-h1 - (resource-h1 * 0.2)) ]
                                if resource-h2 > h4-h2 [set resource-h2 (resource-h2 - (resource-h2 * 0.2)) ]]
                       ask patches with [habitat = 5 and (resource-g1 > h5-g1 or resource-h1 > h5-h1 or resource-g2 > h5-g2 or resource-h2 > h5-h2) ]
                               [if resource-g1 > h5-g1 [set resource-g1 (resource-g1 - (resource-g1 * 0.2)) ]
                                if resource-g2 > h5-g2 [set resource-g2 (resource-g2 - (resource-g2 * 0.2)) ]
                                if resource-h1 > h5-h1 [set resource-h1 (resource-h1 - (resource-h1 * 0.2)) ]
                                if resource-h2 > h5-h2 [set resource-h2 (resource-h2 - (resource-h2 * 0.2)) ]]
                       ask patches with [habitat = 6 and (resource-g1 > h4-g1 or resource-h1 > h4-h1 or resource-g2 > h4-g2 or resource-h2 > h4-h2) ]
                               [if resource-g1 > h6-g1 [set resource-g1 (resource-g1 - (resource-g1 * 0.2)) ]
                                if resource-g2 > h6-g2 [set resource-g2 (resource-g2 - (resource-g2 * 0.2)) ]
                                if resource-h1 > h6-h1 [set resource-h1 (resource-h1 - (resource-h1 * 0.2)) ]
                                if resource-h2 > h6-h2 [set resource-h2 (resource-h2 - (resource-h2 * 0.2)) ]]
          ;;           ]


          if day = 0 or month = 4 or month = 10 [update-map]



    end


    to update-map

      let glacial true
      if (EnvironScen = 2 and ((year > 100 and year < 200) or (year > 800 and year < 1000))) or EnvironScen = 3 [set glacial false]

      if MapType = "Habitats"  [ask patches [set pcolor org-color]]

                       if MapType = "Vegetation"   [
                                                    ifelse (glacial = false)
                                                        [
                                                         ifelse (month < 4 or month >= 10)
                                                             [
                                                               ask patches with [class = 5 or class = 6] [set pcolor 58]
                                                               ask patches with [class = 8 or class = 7] [set pcolor white]
                                                               ask patches with [class = 4] [set pcolor 57]
                                                               ask patches with [class = 3] [ask neighbors [set pcolor 55] ask n-of 4 neighbors [set pcolor 54]]
                                                               ask patches with [class = 3] [set pcolor 54]
                                                               ask patches with [class = 2] [ifelse random 3 = 1 [set pcolor 55] [set pcolor 54]]
                                                               ask patches with [class = 1] [set pcolor 54]

                                                               ]
                                                             [
                                                               ask patches with [class = 4] [set pcolor 56]
                                                               ask patches with [class = 5 or class = 6] [set pcolor 57]
                                                               ask patches with [class = 7] [set pcolor 53]
                                                               ask patches with [class = 8] [set pcolor grey]
                                                               ask patches with [class = 3] [ask neighbors [set pcolor 55] ask n-of 4 neighbors [set pcolor 54]]
                                                               ask patches with [class = 3] [set pcolor 54]
                                                               ask patches with [class = 2] [ifelse random 3 = 1 [set pcolor 55] [set pcolor 54]]
                                                               ask patches with [class = 1] [set pcolor 54]

                                                             ]

                                                        ]
                                                        [
                                                         ifelse (month < 4 or month >= 10)
                                                             [
                                                               ask patches with [class = 5 or class = 6] [set pcolor 79]
                                                               ask patches with [class = 7 or class = 8] [set pcolor white]
                                                               ask patches with [class = 3] [ask neighbors [set pcolor 56] set pcolor 57]
                                                               ask patches with [class = 1 or class = 2 or class = 4 ] [set pcolor 58]



                                                               ]
                                                             [
                                                               ask patches with [class = 5 or class = 6 or class = 7] [set pcolor 77]
                                                               ask patches with [class = 8] [set pcolor grey]
                                                               ask patches with [class = 1 or class = 2 or class = 4 ] [set pcolor 57]
                                                               ask patches with [class = 3] [set pcolor 54 ask one-of neighbors [set pcolor 55] ask one-of neighbors [set pcolor 57]]
                                                               ask patches with [class = 3] []
                                                             ]

                                                        ]

                                                   ]
                       if MapType = "Physical" [ import-pcolors "WP-Rivers-3.jpg" ask patches with [pcolor = 24.7] [set pcolor 36]]


                       if MapType = "ResourcesG" [ let mean-resource mean [resource-g1] of patches with [resource-g1 > 10000]
                                                  ask patches with [resource-g1 >= (mean-resource * 0.8) and resource-g1 < (mean-resource * 1.2)][set pcolor 76]
                                                  ask patches with [resource-g1 >= (mean-resource * 0.5) and resource-g1 < (mean-resource * 0.8)][set pcolor 77]
                                                  ask patches with [resource-g1 >= (mean-resource * 0.25) and resource-g1 < (mean-resource * 0.5)][set pcolor 78]
                                                  ask patches with [resource-g1 >= (mean-resource * 0.05) and resource-g1 < (mean-resource * 0.25)][set pcolor 79]
                                                  ask patches with [ resource-g1 < (mean-resource * 0.05)][set pcolor white]

                                                  ask patches with [resource-g1 >= (mean-resource * 1.2) and resource-g1 < (mean-resource * 1.5)][set pcolor 75]
                                                  ask patches with [resource-g1 >= (mean-resource * 1.5) and resource-g1 < (mean-resource * 1.75)][set pcolor 78]
                                                  ask patches with [resource-g1 >= (mean-resource * 1.75) and resource-g1 < (mean-resource * 1.95)][set pcolor 79]
                                                  ask patches with [ resource-g1 >= (mean-resource * 1.95)][set pcolor 80]
                                                  ]
                       if MapType = "ResourcesH" [ let mean-resource mean [resource-h1] of patches with [resource-h1 > 5000]
                                                  ask patches with [resource-h1 >= (mean-resource * 0.8) and resource-h1 < (mean-resource * 1.2)][set pcolor 36]
                                                  ask patches with [resource-h1 >= (mean-resource * 0.5) and resource-h1 < (mean-resource * 0.8)][set pcolor 37]
                                                  ask patches with [resource-h1 >= (mean-resource * 0.25) and resource-h1 < (mean-resource * 0.5)][set pcolor 38]
                                                  ask patches with [resource-h1 >= (mean-resource * 0.05) and resource-h1 < (mean-resource * 0.25)][set pcolor 39]
                                                  ask patches with [ resource-h1 < (mean-resource * 0.05)][set pcolor white]

                                                  ask patches with [resource-h1 >= (mean-resource * 1.2) and resource-h1 < (mean-resource * 1.5)][set pcolor 35]
                                                  ask patches with [resource-h1 >= (mean-resource * 1.5) and resource-h1 < (mean-resource * 1.75)][set pcolor 38]
                                                  ask patches with [resource-h1 >= (mean-resource * 1.75) and resource-h1 < (mean-resource * 1.95)][set pcolor 39]
                                                  ask patches with [ resource-h1 >= (mean-resource * 1.95)][set pcolor 40]
                                                  ]
    end

    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
    ;;  4 Forager Demographic Procedures
    ;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

    to demo-procedures

                                      check-death
                                      set age (age + 1)
                                      if age = 15 [set size 1.2]
                                      if age = 10 [set known-patches patches in-radius 6]
                                      if PopSize > count humans and gender = 0 and age < 50 and age > 18 and not any? children with [age < 2] and happiness > 10  [check-birth]
                                      if gender = 0 and age > 16 and age < 50 and partner = nobody [check-potential-partners]
                                      if gender = 1 and age > 19 and age < 50 and partner = nobody [check-potential-partners]
                                      set general-happiness false
    end

    to check-death

      let do-i-die random-float 1

         ifelse gender = 0 [
                         if age < 1  [if do-i-die < 0.25611 [die]]
                         if age = 1  [if do-i-die < 0.17794 [die]]
                         if age = 5  [if do-i-die < 0.05024 [die]]
                         if age = 10 [if do-i-die < 0.03927 [die]]
                         if age = 15 [if do-i-die < 0.05125 [die]]
                         if age = 20 [if do-i-die < 0.06399 [check-consequences die]]
                         if age = 25 [if do-i-die < 0.07166 [check-consequences die]]
                         if age = 30 [if do-i-die < 0.08083 [check-consequences die]]
                         if age = 35 [if do-i-die < 0.08854 [check-consequences die]]
                         if age = 40 [if do-i-die < 0.09489 [check-consequences die]]
                         if age = 45 [if do-i-die < 0.10226 [check-consequences die]]
                         if age = 50 [if do-i-die < 0.13142 [check-consequences die]]
                         if age = 55 [if do-i-die < 0.16585 [check-consequences die]]
                         if age = 60 [if do-i-die < 0.23678 [check-consequences die]]
                         if age = 65 [if do-i-die < 0.30864 [check-consequences die]]
                         if age = 70 [if do-i-die < 0.4239  [die]]
                         if age = 75 [if do-i-die < 0.55744 [die]]
                         if age = 80 [if do-i-die < 0.69559 [die]]
                         if age = 85 [if do-i-die < 0.83746 [die]]
                         if age = 90 [if do-i-die < 0.93767 [die]]
                         if age > 95 [die]
                         ]
                        [
                         if age < 1  [if do-i-die < 0.29589 [die]]
                         if age = 1  [if do-i-die < 0.17741 [die]]
                         if age = 5  [if do-i-die < 0.04696 [die]]
                         if age = 10 [if do-i-die < 0.0338  [die]]
                         if age = 15 [if do-i-die < 0.04604 [check-consequences die]]
                         if age = 20 [if do-i-die < 0.06525 [check-consequences die]]
                         if age = 25 [if do-i-die < 0.07287 [check-consequences die]]
                         if age = 30 [if do-i-die < 0.08404 [check-consequences die]]
                         if age = 35 [if do-i-die < 0.09821 [check-consequences die]]
                         if age = 40 [if do-i-die < 0.11803 [check-consequences die]]
                         if age = 45 [if do-i-die < 0.1364  [check-consequences die]]
                         if age = 50 [if do-i-die < 0.17082 [check-consequences die]]
                         if age = 55 [if do-i-die < 0.20633 [check-consequences die]]
                         if age = 60 [if do-i-die < 0.27371 [check-consequences die]]
                         if age = 65 [if do-i-die < 0.35222 [check-consequences die]]
                         if age = 70 [if do-i-die < 0.45965 [check-consequences die]]
                         if age = 75 [if do-i-die < 0.60069 [check-consequences die]]
                         if age = 80 [if do-i-die < 0.72675 [check-consequences die]]
                         if age = 85 [if do-i-die < 0.85732 [die]]
                         if age = 90 [if do-i-die < 0.94619 [die]]
                         if age > 95 [die]
                         ]

    end

    to check-consequences

      if any? children with [age < 15] and partner = nobody
              [let potential-adoption-parents humans-here with [age > 15]
               ifelse any? potential-adoption-parents [let parent one-of potential-adoption-parents
                                                       ask parent [set children (turtle-set children ([children with [age < 10]] of myself))]
                                                       if [partner] of parent != nobody [ask [partner] of parent [set children (turtle-set children ([children with [age < 10]] of myself))]]]
                                                       [ask children with [age < 10] [die]]
              ]
       if partner != nobody [ask partner [set partner nobody]]

    end

    to check-potential-partners                                                               ;; HGPop: MatComp


      let potential-partners nobody
      ifelse gender = 0 [set potential-partners humans with [gender = 1 and partner = nobody and age > [age] of myself and age <= ([age] of myself + 10) and not member? self [children] of humans with [member? myself children]]]
                        [set potential-partners humans with [gender = 0 and partner = nobody and age < [age] of myself and age > 16 and age >= ([age] of myself - 10) and not member? self [children] of humans with [member? myself children]]]



      if any? potential-partners [let mypartner min-one-of potential-partners [distance myself]
                                  set partner mypartner
                                  ask mypartner [set partner myself]
                                  set camp [camp] of mypartner
                                  move-to mypartner
                                  if any? children with [age < 15] [ask children with [age < 15] [set camp [camp] of mypartner move-to mypartner ask mypartner [set children (turtle-set children myself)]]]
                                  ]

    end


    to check-birth

     let birth-chance random-float 2
     if birth-chance < (33.5 / age)
         [
           let child nobody
           hatch 1
              [set age 0
               set birthday month
               set gender random 2
               new-human
               set partner nobody
               set children (turtle-set)
               set size 1
               set energy_need 0
               set food-g 0 set food-h 0
               ;;set target nobody
               set action 0
               set happiness 0
               if patch-here != camp [set action 5]
               set child self
               set known-patches []
               ]
            set children (turtle-set children child)
            if partner != nobody [ask partner [set children (turtle-set children child)]]
          ]


    end




;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;; 5. Plots
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;







;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;;
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


@#$#@#$#@
GRAPHICS-WINDOW
210
95
808
522
-1
-1
12.0
1
10
1
1
1
0
0
0
1
0
48
0
32
0
0
1
ticks
30.0

BUTTON
16
147
86
199
NIL
setup\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
86
147
160
199
NIL
go
T
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SLIDER
19
245
163
278
EnvironScen
EnvironScen
1
3
1
1
1
NIL
HORIZONTAL

MONITOR
635
30
692
75
NIL
day
17
1
11

MONITOR
692
30
749
75
NIL
month
17
1
11

MONITOR
749
30
806
75
NIL
year
17
1
11

PLOT
825
30
1150
180
Human Agents
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"#humans" 1.0 0 -16777216 true "" "plot count humans"
"#unhappy" 1.0 0 -2674135 true "" "plot count humans with [happiness < 0]"
"#patches" 1.0 0 -10899396 true "" "plot ( count humans  / (count patches with [any? humans-here]))"

TEXTBOX
21
217
171
235
Environment
14
73.0
1

TEXTBOX
24
361
174
379
Humans
14
74.0
1

TEXTBOX
14
10
181
85
Gravettian HG\nMobility (Basque)\nLocal
18
0.0
1

TEXTBOX
90
67
181
137
Version 1.2\nAugust 2015\n\nMap 49x33 km\nPatch: 1x1 km
11
0.0
1

PLOT
825
366
1150
521
Mean Distances Moved
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"camp" 1.0 0 -14835848 true "" "plot mean camp-move-distance"
"forage" 1.0 0 -2674135 true "" "if any? humans with [age > 14 and gender = 1 and mean last-distance > 0]\n[plot mean [mean last-distance] of humans with [age > 14 and gender = 1 and mean last-distance > 0]]"

SLIDER
19
388
165
421
PopSize
PopSize
0
500
120
20
1
NIL
HORIZONTAL

SLIDER
19
421
165
454
GroupSize
GroupSize
0
100
30
5
1
NIL
HORIZONTAL

SLIDER
18
278
162
311
EnvironQuality
EnvironQuality
0
100
47
1
1
NIL
HORIZONTAL

SWITCH
19
454
165
487
Sharing
Sharing
0
1
-1000

PLOT
825
196
1150
351
Camps
NIL
NIL
0.0
10.0
0.0
10.0
true
true
"" ""
PENS
"#camps" 1.0 0 -16777216 true "" "plot count camp-sites"
"mean size" 1.0 0 -5298144 true "" "plot mean [count humans with [camp = myself]] of camp-sites"

CHOOSER
207
30
351
75
MapType
MapType
"Physical" "Habitats" "Vegetation" "ResourcesH" "ResourcesG"
1

SLIDER
18
311
162
344
Uncertainty
Uncertainty
0
100
50
1
1
NIL
HORIZONTAL

CHOOSER
19
486
165
531
Scenario
Scenario
"Flexible" "Flexible-Special" "Special"
0

BUTTON
351
30
449
75
Update Map
update-map\n
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

SWITCH
464
30
554
63
Draw
Draw
1
1
-1000

BUTTON
553
30
620
63
Delete
clear-drawing
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
210
540
322
585
movie start
movie-start \"FlexGrav.mov\"
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

BUTTON
335
540
445
585
movie stop
movie-close
NIL
1
T
OBSERVER
NIL
NIL
NIL
NIL
1

MONITOR
750
540
807
585
winter
winter
17
1
11

@#$#@#$#@
## WHAT IS IT?

(a general understanding of what the model is trying to show or explain)

## HOW IT WORKS

(what rules the agents use to create the overall behavior of the model)

## HOW TO USE IT

(how to use the model, including a description of each of the items in the Interface tab)

## THINGS TO NOTICE

(suggested things for the user to notice while running the model)

## THINGS TO TRY

(suggested things for the user to try to do (move sliders, switches, etc.) with the model)

## EXTENDING THE MODEL

(suggested things to add or change in the Code tab to make the model more complicated, detailed, accurate, etc.)

## NETLOGO FEATURES

(interesting or unusual features of NetLogo that the model uses, particularly in the Code tab; or where workarounds were needed for missing features)

## RELATED MODELS

(models in the NetLogo Models Library and elsewhere which are of related interest)

## CREDITS AND REFERENCES

(a reference to the model's URL on the web if it has one, as well as any other necessary credits, citations, and links)
@#$#@#$#@
default
true
0
Polygon -7500403 true true 150 5 40 250 150 205 260 250

airplane
true
0
Polygon -7500403 true true 150 0 135 15 120 60 120 105 15 165 15 195 120 180 135 240 105 270 120 285 150 270 180 285 210 270 165 240 180 180 285 195 285 165 180 105 180 60 165 15

arrow
true
0
Polygon -7500403 true true 150 0 0 150 105 150 105 293 195 293 195 150 300 150

box
false
0
Polygon -7500403 true true 150 285 285 225 285 75 150 135
Polygon -7500403 true true 150 135 15 75 150 15 285 75
Polygon -7500403 true true 15 75 15 225 150 285 150 135
Line -16777216 false 150 285 150 135
Line -16777216 false 150 135 15 75
Line -16777216 false 150 135 285 75

bug
true
0
Circle -7500403 true true 96 182 108
Circle -7500403 true true 110 127 80
Circle -7500403 true true 110 75 80
Line -7500403 true 150 100 80 30
Line -7500403 true 150 100 220 30

butterfly
true
0
Polygon -7500403 true true 150 165 209 199 225 225 225 255 195 270 165 255 150 240
Polygon -7500403 true true 150 165 89 198 75 225 75 255 105 270 135 255 150 240
Polygon -7500403 true true 139 148 100 105 55 90 25 90 10 105 10 135 25 180 40 195 85 194 139 163
Polygon -7500403 true true 162 150 200 105 245 90 275 90 290 105 290 135 275 180 260 195 215 195 162 165
Polygon -16777216 true false 150 255 135 225 120 150 135 120 150 105 165 120 180 150 165 225
Circle -16777216 true false 135 90 30
Line -16777216 false 150 105 195 60
Line -16777216 false 150 105 105 60

car
false
0
Polygon -7500403 true true 300 180 279 164 261 144 240 135 226 132 213 106 203 84 185 63 159 50 135 50 75 60 0 150 0 165 0 225 300 225 300 180
Circle -16777216 true false 180 180 90
Circle -16777216 true false 30 180 90
Polygon -16777216 true false 162 80 132 78 134 135 209 135 194 105 189 96 180 89
Circle -7500403 true true 47 195 58
Circle -7500403 true true 195 195 58

circle
false
0
Circle -7500403 true true 0 0 300

circle 2
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240

cow
false
0
Polygon -7500403 true true 200 193 197 249 179 249 177 196 166 187 140 189 93 191 78 179 72 211 49 209 48 181 37 149 25 120 25 89 45 72 103 84 179 75 198 76 252 64 272 81 293 103 285 121 255 121 242 118 224 167
Polygon -7500403 true true 73 210 86 251 62 249 48 208
Polygon -7500403 true true 25 114 16 195 9 204 23 213 25 200 39 123

cylinder
false
0
Circle -7500403 true true 0 0 300

dot
false
0
Circle -7500403 true true 90 90 120

face happy
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 255 90 239 62 213 47 191 67 179 90 203 109 218 150 225 192 218 210 203 227 181 251 194 236 217 212 240

face neutral
false
0
Circle -7500403 true true 8 7 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Rectangle -16777216 true false 60 195 240 225

face sad
false
0
Circle -7500403 true true 8 8 285
Circle -16777216 true false 60 75 60
Circle -16777216 true false 180 75 60
Polygon -16777216 true false 150 168 90 184 62 210 47 232 67 244 90 220 109 205 150 198 192 205 210 220 227 242 251 229 236 206 212 183

fish
false
0
Polygon -1 true false 44 131 21 87 15 86 0 120 15 150 0 180 13 214 20 212 45 166
Polygon -1 true false 135 195 119 235 95 218 76 210 46 204 60 165
Polygon -1 true false 75 45 83 77 71 103 86 114 166 78 135 60
Polygon -7500403 true true 30 136 151 77 226 81 280 119 292 146 292 160 287 170 270 195 195 210 151 212 30 166
Circle -16777216 true false 215 106 30

flag
false
0
Rectangle -7500403 true true 60 15 75 300
Polygon -7500403 true true 90 150 270 90 90 30
Line -7500403 true 75 135 90 135
Line -7500403 true 75 45 90 45

flower
false
0
Polygon -10899396 true false 135 120 165 165 180 210 180 240 150 300 165 300 195 240 195 195 165 135
Circle -7500403 true true 85 132 38
Circle -7500403 true true 130 147 38
Circle -7500403 true true 192 85 38
Circle -7500403 true true 85 40 38
Circle -7500403 true true 177 40 38
Circle -7500403 true true 177 132 38
Circle -7500403 true true 70 85 38
Circle -7500403 true true 130 25 38
Circle -7500403 true true 96 51 108
Circle -16777216 true false 113 68 74
Polygon -10899396 true false 189 233 219 188 249 173 279 188 234 218
Polygon -10899396 true false 180 255 150 210 105 210 75 240 135 240

house
false
0
Rectangle -7500403 true true 45 120 255 285
Rectangle -16777216 true false 120 210 180 285
Polygon -7500403 true true 15 120 150 15 285 120
Line -16777216 false 30 120 270 120

leaf
false
0
Polygon -7500403 true true 150 210 135 195 120 210 60 210 30 195 60 180 60 165 15 135 30 120 15 105 40 104 45 90 60 90 90 105 105 120 120 120 105 60 120 60 135 30 150 15 165 30 180 60 195 60 180 120 195 120 210 105 240 90 255 90 263 104 285 105 270 120 285 135 240 165 240 180 270 195 240 210 180 210 165 195
Polygon -7500403 true true 135 195 135 240 120 255 105 255 105 285 135 285 165 240 165 195

line
true
0
Line -7500403 true 150 0 150 300

line half
true
0
Line -7500403 true 150 0 150 150

pentagon
false
0
Polygon -7500403 true true 150 15 15 120 60 285 240 285 285 120

person
false
0
Circle -7500403 true true 110 5 80
Polygon -7500403 true true 105 90 120 195 90 285 105 300 135 300 150 225 165 300 195 300 210 285 180 195 195 90
Rectangle -7500403 true true 127 79 172 94
Polygon -7500403 true true 195 90 240 150 225 180 165 105
Polygon -7500403 true true 105 90 60 150 75 180 135 105

plant
false
0
Rectangle -7500403 true true 135 90 165 300
Polygon -7500403 true true 135 255 90 210 45 195 75 255 135 285
Polygon -7500403 true true 165 255 210 210 255 195 225 255 165 285
Polygon -7500403 true true 135 180 90 135 45 120 75 180 135 210
Polygon -7500403 true true 165 180 165 210 225 180 255 120 210 135
Polygon -7500403 true true 135 105 90 60 45 45 75 105 135 135
Polygon -7500403 true true 165 105 165 135 225 105 255 45 210 60
Polygon -7500403 true true 135 90 120 45 150 15 180 45 165 90

sheep
false
15
Circle -1 true true 203 65 88
Circle -1 true true 70 65 162
Circle -1 true true 150 105 120
Polygon -7500403 true false 218 120 240 165 255 165 278 120
Circle -7500403 true false 214 72 67
Rectangle -1 true true 164 223 179 298
Polygon -1 true true 45 285 30 285 30 240 15 195 45 210
Circle -1 true true 3 83 150
Rectangle -1 true true 65 221 80 296
Polygon -1 true true 195 285 210 285 210 240 240 210 195 210
Polygon -7500403 true false 276 85 285 105 302 99 294 83
Polygon -7500403 true false 219 85 210 105 193 99 201 83

sheep 2
false
0
Polygon -7500403 true true 209 183 194 198 179 198 164 183 164 174 149 183 89 183 74 168 59 198 44 198 29 185 43 151 28 121 44 91 59 80 89 80 164 95 194 80 254 65 269 80 284 125 269 140 239 125 224 153 209 168
Rectangle -7500403 true true 180 195 195 225
Rectangle -7500403 true true 45 195 60 225
Rectangle -16777216 true false 180 225 195 240
Rectangle -16777216 true false 45 225 60 240
Polygon -7500403 true true 245 60 250 72 240 78 225 63 230 51
Polygon -7500403 true true 25 72 40 80 42 98 22 91
Line -16777216 false 270 137 251 122
Line -16777216 false 266 90 254 90

square
false
0
Rectangle -7500403 true true 30 30 270 270

square 2
false
0
Rectangle -7500403 true true 30 30 270 270
Rectangle -16777216 true false 60 60 240 240

star
false
0
Polygon -7500403 true true 151 1 185 108 298 108 207 175 242 282 151 216 59 282 94 175 3 108 116 108

target
false
0
Circle -7500403 true true 0 0 300
Circle -16777216 true false 30 30 240
Circle -7500403 true true 60 60 180
Circle -16777216 true false 90 90 120
Circle -7500403 true true 120 120 60

tree
false
0
Circle -7500403 true true 118 3 94
Rectangle -6459832 true false 120 195 180 300
Circle -7500403 true true 65 21 108
Circle -7500403 true true 116 41 127
Circle -7500403 true true 45 90 120
Circle -7500403 true true 104 74 152

triangle
false
0
Polygon -7500403 true true 150 30 15 255 285 255

triangle 2
false
0
Polygon -7500403 true true 150 30 15 255 285 255
Polygon -16777216 true false 151 99 225 223 75 224

truck
false
0
Rectangle -7500403 true true 4 45 195 187
Polygon -7500403 true true 296 193 296 150 259 134 244 104 208 104 207 194
Rectangle -1 true false 195 60 195 105
Polygon -16777216 true false 238 112 252 141 219 141 218 112
Circle -16777216 true false 234 174 42
Rectangle -7500403 true true 181 185 214 194
Circle -16777216 true false 144 174 42
Circle -16777216 true false 24 174 42
Circle -7500403 false true 24 174 42
Circle -7500403 false true 144 174 42
Circle -7500403 false true 234 174 42

turtle
true
0
Polygon -10899396 true false 215 204 240 233 246 254 228 266 215 252 193 210
Polygon -10899396 true false 195 90 225 75 245 75 260 89 269 108 261 124 240 105 225 105 210 105
Polygon -10899396 true false 105 90 75 75 55 75 40 89 31 108 39 124 60 105 75 105 90 105
Polygon -10899396 true false 132 85 134 64 107 51 108 17 150 2 192 18 192 52 169 65 172 87
Polygon -10899396 true false 85 204 60 233 54 254 72 266 85 252 107 210
Polygon -7500403 true true 119 75 179 75 209 101 224 135 220 225 175 261 128 261 81 224 74 135 88 99

wheel
false
0
Circle -7500403 true true 3 3 294
Circle -16777216 true false 30 30 240
Line -7500403 true 150 285 150 15
Line -7500403 true 15 150 285 150
Circle -7500403 true true 120 120 60
Line -7500403 true 216 40 79 269
Line -7500403 true 40 84 269 221
Line -7500403 true 40 216 269 79
Line -7500403 true 84 40 221 269

wolf
false
0
Polygon -16777216 true false 253 133 245 131 245 133
Polygon -7500403 true true 2 194 13 197 30 191 38 193 38 205 20 226 20 257 27 265 38 266 40 260 31 253 31 230 60 206 68 198 75 209 66 228 65 243 82 261 84 268 100 267 103 261 77 239 79 231 100 207 98 196 119 201 143 202 160 195 166 210 172 213 173 238 167 251 160 248 154 265 169 264 178 247 186 240 198 260 200 271 217 271 219 262 207 258 195 230 192 198 210 184 227 164 242 144 259 145 284 151 277 141 293 140 299 134 297 127 273 119 270 105
Polygon -7500403 true true -1 195 14 180 36 166 40 153 53 140 82 131 134 133 159 126 188 115 227 108 236 102 238 98 268 86 269 92 281 87 269 103 269 113

x
false
0
Polygon -7500403 true true 270 75 225 30 30 225 75 270
Polygon -7500403 true true 30 75 75 30 270 225 225 270

@#$#@#$#@
NetLogo 5.3.1
@#$#@#$#@
@#$#@#$#@
@#$#@#$#@
<experiments>
  <experiment name="Basque FlexGroups" repetitions="4" runMetricsEveryStep="true">
    <setup>setup</setup>
    <go>go</go>
    <metric>count turtles</metric>
    <metric>count camp-sites</metric>
    <enumeratedValueSet variable="Innovation">
      <value value="2"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="GroupSize">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="PopSize">
      <value value="600"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="ResourceView">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="EnvironQuality">
      <value value="15"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="Sharing">
      <value value="true"/>
    </enumeratedValueSet>
    <enumeratedValueSet variable="EnvironScen">
      <value value="2"/>
    </enumeratedValueSet>
  </experiment>
</experiments>
@#$#@#$#@
@#$#@#$#@
default
0.0
-0.2 0 0.0 1.0
0.0 1 1.0 0.0
0.2 0 0.0 1.0
link direction
true
0
Line -7500403 true 150 150 90 180
Line -7500403 true 150 150 210 180

@#$#@#$#@
1
@#$#@#$#@
